给定一个无重复元素的正整数数组 candidates 和一个正整数 target ,找出 candidates 中所有可以使数字和为目标数 target 的唯一组合。
candidates 中的数字可以无限制重复被选取。如果至少一个所选数字数量不同,则两种组合是唯一的。
对于给定的输入,保证和为 target 的唯一组合数少于 150 个。
示例 1:
输入: candidates = [2,3,6,7], target = 7
输出: [[7],[2,2,3]]
示例 2:
输入: candidates = [2,3,5], target = 8
输出: [[2,2,2,2],[2,3,3],[3,5]]
示例 3:
输入: candidates = [2], target = 1
输出: []
示例 4:
输入: candidates = [1], target = 1
输出: [[1]]
示例 5:
输入: candidates = [1], target = 2
输出: [[1,1]]
提示:
- 1 <= candidates.length <= 30
- 1 <= candidates[i] <= 200
- candidate
中的每个元素都是独一无二的。
1 <= target <= 500
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/combination-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
思路:遍历每一种情况,因为可以重复取值,所以下一层的开始位置是i,为了避免出现重复的结果,所以先排序,(如果横向遍历中,当前值和前一个值一样,则跳过,因为前一个值已经将该情况遍历过了)
class Solution {
/**
1. 给的候选的值是无重复的
2. 可以重复取值。
3. 要保证结果的无重复
*/
List<List<Integer>> ret = new ArrayList<>();
Stack<Integer> stack = new Stack<>();
public List<List<Integer>> combinationSum(int[] candidates, int target) {
// 最重要的是排序,防止出现重复值的情况
Arrays.sort(candidates);
dfs(candidates,target,0,0);
return ret;
}
/**
index:以该位置开始。
*/
private void dfs(int[] candidates,int target,int num, int index) {
if(num == target) {
List<Integer> list = new ArrayList<>(stack);
ret.add(list);
return;
}
// 值已经大于了,直接返回
if(num > target) {
return;
}
// 因为是可以重复取值的,所以从0开始
for(int i=index;i<candidates.length;i++) {
// 结果去重
// 如果和前一个值是一样的,说明该情况已经遍历过了,不再遍历
if(i>index && candidates[i] == candidates[i-1]) {
continue;
}
// 放入结果
stack.push(candidates[i]);
// 因为可以重复取值,所以下一层的开始位置和当前位置的开始位置一样
dfs(candidates,target,num+candidates[i],i);
// 该位置遍历完成后需要把结果移除。
stack.pop();
}
}
}